=== added file 'src/com/goldencode/p2j/ui/WidgetExtension.java'
--- src/com/goldencode/p2j/ui/WidgetExtension.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/WidgetExtension.java	2020-02-24 19:18:25 +0000
@@ -0,0 +1,131 @@
+/*
+** Module   : WidgetExtension.java
+** Abstract : WidgetExtension interface.
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- --------------------------------Description-----------------------------------
+** 001 SBI 20200114 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+package com.goldencode.p2j.ui;
+
+import com.goldencode.p2j.util.*;
+
+
+/**
+ * Defines additional common methods of a UI component that extends legacy widget methods.
+ */
+public interface WidgetExtension
+{
+   /**
+    * Gets the type of mouse pointer displayed when over part of an object.
+    * 
+    * @return mouse pointer
+    */
+   @LegacyAttribute(name = "MOUSE-POINTER-NUM")
+   public integer getMousePointerNum();
+
+   /**
+    * Sets the type of mouse pointer displayed when over part of an object.
+    * 
+    * @param   value
+    *          new mouse pointer
+    */
+   @LegacyAttribute(name = "MOUSE-POINTER-NUM", setter = true)
+   public void setMousePointerNum(integer value);
+
+   /**
+    * Sets the type of mouse pointer displayed when over part of an object.
+    * 
+    * @param   value
+    *          new mouse pointer
+    */
+   @LegacyAttribute(name = "MOUSE-POINTER-NUM", setter = true)
+   public void setMousePointerNum(int value);
+
+   /**
+    * Gets a mouse icon for this control.
+    * 
+    * @return   The mouse icon for this control
+    */
+   @LegacyAttribute(name = "MOUSE-ICON")
+   public character getMouseIcon();
+
+   /**
+    * Sets a custom mouse icon for this control.
+    * 
+    * @param   value
+    *          The user defined mouse icon
+    */
+   @LegacyAttribute(name = "MOUSE-ICON", setter = true)
+   public void setMouseIcon(character value);
+   
+   /**
+    * Sets a custom mouse icon.
+    * 
+    * @param   value
+    *          user defined mouse icon
+    */
+   @LegacyAttribute(name = "MOUSE-ICON", setter = true)
+   public void setMouseIcon(String value);
+   
+   /**
+    * Forces a complete repaint of a form or control.
+    */
+   @LegacyMethod(name = "REFRESH-UI")
+   public void refreshUI();
+}

=== modified file 'src/com/goldencode/p2j/ui/client/UiUtils.java'
--- src/com/goldencode/p2j/ui/client/UiUtils.java	2020-01-21 14:39:51 +0000
+++ src/com/goldencode/p2j/ui/client/UiUtils.java	2020-02-25 16:59:06 +0000
@@ -2,7 +2,7 @@
 ** Module   : UiUtils.java
 ** Abstract : UI-modality-independent helper methods
 **
-** Copyright (c) 2010-2019, Golden Code Development Corporation.
+** Copyright (c) 2010-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 SIY 20100821 Created initial version
@@ -80,6 +80,7 @@
 **     HC  20191231 Fixed getCurrentFocus(boolean) to return legacy widget when legacy requested.
 ** 092 MAG 20191106 Initial implementation of IMAGELIST widget.
 ** 093 MAG 20191003 Implemented PROGRESS-BAR widget and related changes.
+** 094 SBI 20200225 Added getDropDownPhysicalLocation.
 */
 
 /*
@@ -147,6 +148,8 @@
 import com.goldencode.p2j.ui.*;
 import com.goldencode.p2j.ui.chui.ThinClient;
 import com.goldencode.p2j.ui.client.gui.*;
+import com.goldencode.p2j.ui.client.gui.driver.*;
+import com.goldencode.p2j.ui.client.gui.theme.*;
 import com.goldencode.p2j.ui.client.widget.*;
 import com.goldencode.p2j.util.*;
 
@@ -752,6 +755,68 @@
    }
 
    /**
+    * Calculates the drop down physical location based on the owner physical location taking
+    * into account that the dropdown belongs to the different parent frame.
+    * 
+    * @param    owner
+    *           The dropdown's owner: combobox, calendar widget
+    * @param    dropdown
+    *           The dropdown widget
+    * @param    gd
+    *           The GUI driver
+    * 
+    * @return   The drop down physical location to set.
+    */
+   public static NativePoint getDropDownPhysicalLocation(AbstractWidget<GuiOutputManager> owner,
+                                                         AbstractWidget<GuiOutputManager> dropdown,
+                                                         GuiDriver gd)
+   {
+      // start GUI specifics
+      // get the absolute coord of the combo-box this drop-down belongs to
+      NativePoint cbbPhysLoc = owner.screenPhysicalLocation();
+      
+      // set the coordinates relative to parent combo-box widget
+      //
+      // The combo-box and drop-down both belong to different frames. The parent frame
+      // for drop-down is border-less and header-less invisible frame located inside Window
+      // workspaces. So when we get the physical location of the combo-box we have location
+      // related to frame the combo-box belongs to. If we use this coords to place drop-down we
+      // have XY shift according to combo-box's frame placement and decoration. That's why we can
+      // not just use combo-box location plus combo box height here.
+      //
+      // The approach is to get absolute coordinates of the combo-box, get the coordinate of the
+      // workspace, subtract second from first and add the combo-box height.
+      
+      // the combo-box height plus some extra pixels to match 4GL look and feel
+      int cbbHeightPlus = dropdown.screen().coordinates().heightToNative(owner.height()) + 
+                          ThemeManager.getCurrentTheme().getComboBoxDropDownOffset();
+      NativePoint ddPhysLoc = new NativePoint(cbbPhysLoc.x, cbbPhysLoc.y);
+      
+      // check if the drop-down will fit the current display dimension
+      // get combo-box window ID
+      int mainWndId = owner.topLevelWindow().getId().asInt();
+      // get combo-box absolute coordinates
+      NativePoint cbbDispLoc = owner.displayPhysicalLocation();
+      // total screen and drop-down dimension
+      NativeRectangle nr = gd.getDisplayBounds(mainWndId);
+      NativeDimension nDim = dropdown.physicalDimension();
+      
+      // calculate final drop-down y coordinate (to display the full list above or below the
+      // parent) based on space available, but the preference will be below if possible
+      if (cbbDispLoc.y + cbbHeightPlus + nDim.height > nr.bottom() &&
+          cbbDispLoc.y - nDim.height > nr.top())
+      {
+         ddPhysLoc.y -= nDim.height;
+      }
+      else
+      {
+         ddPhysLoc.y += cbbHeightPlus;
+      }
+      
+      return ddPhysLoc;
+   }
+   
+   /**
     * Return the alert box which contains the specified widget.
     *
     * @param    widget
@@ -1008,6 +1073,10 @@
       {
          clazz = ProgressBarGuiImpl.class;
       }
+      else if (cfgCls == CalendarConfig.class)
+      {
+         clazz = CalendarGuiImpl.class;
+      }
       
       return OutputManager.instance().getFactory().create(clazz, id, cfg);
    }

=== modified file 'src/com/goldencode/p2j/ui/client/gui/ButtonGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/ButtonGuiImpl.java	2019-12-02 20:57:20 +0000
+++ src/com/goldencode/p2j/ui/client/gui/ButtonGuiImpl.java	2020-02-25 16:57:54 +0000
@@ -2,7 +2,7 @@
 ** Module   : ButtonGuiImpl.java
 ** Abstract : push button implementation for GUI
 **
-** Copyright (c) 2014-2019, Golden Code Development Corporation.
+** Copyright (c) 2014-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description---------------------------------
 ** 001 EVL 20141120 Initial version.
@@ -91,6 +91,7 @@
 **         20190802 Added canProduceAction to handleBasicEvents, so that suitable key inputs
 **                  generate ActionEvents.
 ** 047 SBI 20191202 Fixed isMnemonicSupported() to return true.
+** 048 SBI 20200225 Reduced the code by using the common code. Fixed button with image usages.
 */
 
 /*
@@ -151,10 +152,10 @@
 // this usage of AWT events is intentional, they are being used separately from the
 // AWT/Swing event model itself; no other AWT/Swing usage is occurring in this class
 import java.awt.event.MouseEvent;
-import java.util.*;
+
+import java.util.function.*;
 
 import com.goldencode.p2j.ui.*;
-import com.goldencode.p2j.ui.chui.*;
 import com.goldencode.p2j.ui.client.*;
 import com.goldencode.p2j.ui.client.event.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
@@ -204,6 +205,9 @@
    /** Image to draw on button in disabled state. */
    private ImageGuiImpl imgDisabled = null;
    
+   /** Indicates that this event is processed by super class implementation logic */
+   private boolean processedBySuperClass;
+   
    /**
     * This constructor creates a button with a given text label.
     * 
@@ -259,7 +263,20 @@
 
       // handle pending images to preload
       loadPendingImages();
-
+      
+      if (imgDisabled != null)
+      {
+         imgDisabled.initialize(imgDisabled.getId(), imgDisabled.config());
+      }
+      if (imgDown != null)
+      {
+         imgDown.initialize(imgDown.getId(), imgDown.config());
+      }
+      if (imgUp != null)
+      {
+         imgUp.initialize(imgUp.getId(), imgUp.config());
+      }
+      
       // adjust image coordinates and width
       recalcImagesCoords();
 
@@ -311,79 +328,15 @@
    {
       boolean result = false;
       
-      switch (type)
+      Images ib = Images.valueOf(type);
+      
+      if (ib == null)
       {
-         case ButtonConfig.IMAGE_UP:
-         {
-            // get the image name
-            String imgName = config().imgUpDef.name;
-            
-            if (imgUp == null)
-            {
-               boolean isIcon = imgName != null && imgName.toLowerCase().contains(".ico");
-               imgUp = new ImageGuiImpl(WidgetId.nextID(), isIcon);
-            }
-            result = imgUp.setImage(image, false);
-            
-            // fixup button coordinates
-            if (result)
-            {
-               fixupImageCoord(imgUp, config().imgUpDef, type);
-               // prepackaged images has transparent background
-               if (ImageHelper.isPrepackaged(imgName))
-               {
-                  imgUp.config().transparent = true;
-               }
-               // if image is used on the top of the button it must have convert-3d-colors on
-               imgUp.config().convert3D = !imgUp.isIcon();
-            }
-            break;
-         }
-         case ButtonConfig.IMAGE_DOWN:
-         {
-            if (imgDown == null)
-            {
-               boolean isIcon = config().imgDownDef.name != null &&
-                                config().imgDownDef.name.toLowerCase().contains(".ico");
-               imgDown = new ImageGuiImpl(WidgetId.nextID(), isIcon);
-            }
-            result = imgDown.setImage(image, false);
-
-            // fixup button coordinates
-            if (result)
-            {
-               fixupImageCoord(imgDown, config().imgDownDef, type);
-               // if image is used on the top of the button it must have convert-3d-colors on
-               imgDown.config().convert3D = !imgDown.isIcon();
-            }
-            break;
-         }
-         case ButtonConfig.IMAGE_INS:
-         {
-            if (imgDisabled == null)
-            {
-               boolean isIcon = config().imgInsDef.name != null &&
-                                config().imgInsDef.name.toLowerCase().contains(".ico");
-               imgDisabled = new ImageGuiImpl(WidgetId.nextID(), isIcon);
-            }
-            result = imgDisabled.setImage(image, false);
-
-            // fixup button coordinates
-            if (result)
-            {
-               fixupImageCoord(imgDisabled, config().imgInsDef, type);
-               // prepackaged images has transparent background
-               if (ImageHelper.isPrepackaged(config().imgInsDef.name))
-               {
-                  imgDisabled.config().transparent = true;
-               }
-               // if image is used on the top of the button it must have convert-3d-colors on
-               imgDisabled.config().convert3D = !imgDisabled.isIcon();
-            }
-            break;
-         }
+         return result;
       }
       
+      result = ib.setImage(this, image);
+      
       // if the image was loaded after button initialization, we need to recalculate new
       // position inside the button
       if (result)
@@ -395,6 +348,36 @@
    }
    
    /**
+    * Sets the new image for given button widget on the client side.
+    * 
+    * @param    type
+    *           Image type to load.  Up, Down or Insensitive for buttons.
+    * @param    image
+    *           The image wrapper.
+    *
+    * @return   <code>TRUE</code> if operation successful <code>FALSE</code> otherwise.
+    */
+   public boolean setImage(int type, ImageWrapper image)
+   {
+      boolean result = false;
+      
+      Images ib = Images.valueOf(type);
+      
+      if (ib == null)
+      {
+         return result;
+      }
+      
+      ib.setImage(this, image);
+      
+      // if the image was loaded after button initialization, we need to recalculate new
+      // position inside the button
+      recalcImagesCoords();
+      
+      return true;
+   }
+   
+   /**
     * Loads the new image for given button widget from the client side filesystem.
     * 
     * @param    type
@@ -408,72 +391,15 @@
    {
       boolean result = false;
       
-      switch (type)
+      Images ib = Images.valueOf(type);
+      
+      if (ib == null)
       {
-         case ButtonConfig.IMAGE_UP:
-         {
-            if (imgUp == null)
-            {
-               imgUp = new ImageGuiImpl(WidgetId.nextID());
-            }
-
-            result = imgUp.loadImage(fullName, false);
-            
-            // fixup button coordinates
-            if (result)
-            {
-               fixupImageCoord(imgUp, config().imgUpDef, type);
-               // prepackaged images has transparent background
-               if (ImageHelper.isPrepackaged(fullName))
-               {
-                  imgUp.config().transparent = true;
-               }
-               // if image is used on the top of the button it must have convert-3d-colors on
-               imgUp.config().convert3D = !imgUp.isIcon();
-            }
-            break;
-         }
-         case ButtonConfig.IMAGE_DOWN:
-         {
-            if (imgDown == null)
-            {
-               imgDown = new ImageGuiImpl(WidgetId.nextID());
-            }
-            result = imgDown.loadImage(fullName, false); 
-
-            // fixup button coordinates
-            if (result)
-            {
-               fixupImageCoord(imgDown, config().imgDownDef, type);
-               // if image is used on the top of the button it must have convert-3d-colors on
-               imgDown.config().convert3D = !imgDown.isIcon();
-            }
-            break;
-         }
-         case ButtonConfig.IMAGE_INS:
-         {
-            if (imgDisabled == null)
-            {
-               imgDisabled = new ImageGuiImpl(WidgetId.nextID());
-            }
-            result = imgDisabled.loadImage(fullName, false); 
-
-            // fixup button coordinates
-            if (result)
-            {
-               fixupImageCoord(imgDisabled, config().imgInsDef, type);
-               // prepackaged images has transparent background
-               if (ImageHelper.isPrepackaged(fullName))
-               {
-                  imgDisabled.config().transparent = true;
-               }
-               // if image is used on the top of the button it must have convert-3d-colors on
-               imgDisabled.config().convert3D = !imgDisabled.isIcon();
-            }
-            break;
-         }
+         return result;
       }
-    
+      
+      result = ib.loadImage(this, fullName);
+      
       // if the image was loaded after button initialization, we need to recalculate new
       // position inside the button
       if (result)
@@ -975,7 +901,7 @@
          repaint();
       }
 
-      if (isEnabled() && event.canProduceAction())
+      if (!processedBySuperClass && isEnabled() && event.canProduceAction())
       {
          EventManager.postEvent(new ActionEvent(this, getCommand()));
       }
@@ -997,6 +923,20 @@
    }
 
    /**
+    * It wraps around its super class implementation.
+    * 
+    * @param    event
+    *           The processed event
+    */
+   @Override
+   public void processEvent(Event event)
+   {
+      processedBySuperClass = true;
+      super.processEvent(event);
+      processedBySuperClass = false;
+   }
+
+   /**
     * Handle cursor movement keys.
     * 
     * @param   key
@@ -1240,4 +1180,155 @@
    {
       return "ButtonGuiImpl{" + String.valueOf(getId()) + ", \"" + textLabel() + "\"}";
    }
+   
+   /**
+    * Defines common methods for up, down and insensitive images for buttons.
+    */
+   public enum Images
+   {
+      IMAGE_UP (ButtonConfig.IMAGE_UP,
+                (b) -> b.config().imgUpDef,
+                (b) -> (img) -> b.imgUp = img,
+                (b) -> b.imgUp),
+      IMAGE_DOWN (ButtonConfig.IMAGE_DOWN,
+                  (b) -> b.config().imgDownDef,
+                  (b) -> (img) -> b.imgDown = img,
+                  (b) -> b.imgDown),
+      IMAGE_INS (ButtonConfig.IMAGE_INS,
+                 (b) -> b.config().imgInsDef,
+                 (b) -> (img) -> b.imgDisabled = img,
+                 (b) -> b.imgDisabled);
+      
+      private final Function<ButtonGuiImpl, ButtonImageDefinition> imageDefinition;
+      
+      private final Function<ButtonGuiImpl, Consumer<ImageGuiImpl>> setter;
+      
+      private final Function<ButtonGuiImpl, ImageGuiImpl> getter;
+      
+      private final int type;
+      
+      private Images(int type,
+                     Function<ButtonGuiImpl, ButtonImageDefinition> imageDefinition,
+                     Function<ButtonGuiImpl, Consumer<ImageGuiImpl>> setter,
+                     Function<ButtonGuiImpl, ImageGuiImpl> getter)
+      {
+         this.type = type;
+         this.imageDefinition = imageDefinition;
+         this.setter = setter;
+         this.getter = getter;
+      }
+      
+      public boolean setImage(ButtonGuiImpl bt, byte[] image)
+      {
+         ButtonImageDefinition btImgDef = imageDefinition.apply(bt);
+         
+         String imgName = btImgDef.name;
+         
+         ImageGuiImpl img = getOrCreate(bt, imgName);
+         
+         boolean result = img.setImage(image, false);
+         
+         if (result)
+         {
+            fixButtonCoordinates(bt, btImgDef, img);
+         }
+
+         return result;
+      }
+      
+      public void setImage(ButtonGuiImpl bt, ImageWrapper image)
+      {
+         ButtonImageDefinition btImgDef = imageDefinition.apply(bt);
+         
+         String imgName = btImgDef.name;
+         
+         ImageGuiImpl img = getOrCreate(bt, imgName);
+         
+         img.setImage(image);
+         
+         fixButtonCoordinates(bt, btImgDef, img);
+      }
+      
+      public boolean loadImage(ButtonGuiImpl bt, String fullName)
+      {
+         ImageGuiImpl img = getOrCreate(bt);
+         
+         boolean result = img.loadImage(fullName, false);
+         
+         // fixup button coordinates
+         if (result)
+         {
+            ButtonImageDefinition btImgDef = imageDefinition.apply(bt);
+            bt.fixupImageCoord(img, btImgDef, type);
+            // prepackaged images has transparent background
+            if (ImageHelper.isPrepackaged(fullName))
+            {
+               img.config().transparent = true;
+            }
+            // if image is used on the top of the button it must have convert-3d-colors on
+            img.config().convert3D = !img.isIcon();
+         }
+         
+         return result;
+      }
+      
+      private ImageGuiImpl getOrCreate(ButtonGuiImpl bt, String imgName)
+      {
+         ImageGuiImpl img = getter.apply(bt);
+         
+         if (img == null)
+         {
+            boolean isIcon = imgName != null && imgName.toLowerCase().contains(".ico");
+            
+            img = new ImageGuiImpl(WidgetId.nextID(), isIcon);
+            
+            setter.apply(bt).accept(img);
+         }
+         
+         return img;
+      }
+      
+      private ImageGuiImpl getOrCreate(ButtonGuiImpl bt)
+      {
+         ImageGuiImpl img = getter.apply(bt);
+         
+         if (img == null)
+         {
+            img = new ImageGuiImpl(WidgetId.nextID());
+            
+            setter.apply(bt).accept(img);
+         }
+         
+         return img;
+      }
+      
+      private void fixButtonCoordinates(ButtonGuiImpl bt,
+                                        ButtonImageDefinition btImgDef,
+                                        ImageGuiImpl img)
+      {
+         String imgName = btImgDef.name;
+         // fixup button coordinates
+         bt.fixupImageCoord(img, btImgDef, type);
+         // prepackaged images has transparent background
+         if (ImageHelper.isPrepackaged(imgName))
+         {
+            img.config().transparent = true;
+         }
+         // if image is used on the top of the button it must have convert-3d-colors on
+         img.config().convert3D = !img.isIcon();
+      }
+      
+      public static Images valueOf(int type)
+      {
+         for(Images ib : Images.values())
+         {
+            if (ib.type == type)
+            {
+               return ib;
+            }
+         }
+         
+         return null;
+      }
+   }
 }

